apiVersion: v1
kind: Service
metadata:
  name: db
spec:
  selector:
    app: portal
    component: etcd
  # TODO: these should be configurable via kustomize
  ports:
    - protocol: "TCP"
      port: 2379
      targetPort: 2379
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: etcd
spec:
  replicas: 1
  selector:
    matchLabels:
      app: portal
      component: etcd
  template:
    metadata:
      labels:
        app: portal
        component: etcd
    spec:
      tolerations:
       - key: dedicated
         operator: Equal
         value: service_worker
         effect: NoSchedule
      containers:
        - name: db
          image: quay.io/coreos/etcd:latest
          env:
            - name: ETCDCTL_API
              value: "3"
            - name: ETCDCTL_ENDPOINTS
              value: localhost:4001
          command: [
            "/usr/local/bin/etcd",
            "--name",                         "db",

            "--cert-file",                    "/etcd/certs/mdb.pem",
            "--key-file",                     "/etcd/certs/mdb-key.pem",
            "--trusted-ca-file",              "/etcd/certs/ca.pem",
            "--peer-cert-file",               "/etcd/certs/mdb.pem",
            "--peer-key-file",                "/etcd/certs/mdb-key.pem",
            "--peer-trusted-ca-file",         "/etcd/certs/ca.pem",
            "--peer-client-cert-auth",
            "--client-cert-auth",

            "--initial-advertise-peer-urls",  "https://localhost:2380",
            "--advertise-client-urls",        "https://localhost:2379",
            "--listen-client-urls",           "https://0.0.0.0:2379,http://localhost:4001",
            "--advertise-client-urls",        "https://localhost:2379",
            "--initial-cluster",              "db=https://localhost:2380",
            "--data-dir",                     "/etcd/data",
            "--max-txn-ops",                  "8192",
            "--max-request-bytes",            "1073741824",
            "--quota-backend-bytes",          "8000000000"
          ]
          ports:
            - name: etcd
              containerPort: 2379
          volumeMounts:
            - name: cert-volume
              mountPath: /etcd/certs
            - name: data-volume
              mountPath: /etcd/data
      volumes:
        - name: cert-volume
          configMap:
            name: merge-db-cert
        - name: data-volume
          persistentVolumeClaim:
            claimName: etcd-pvc
            readOnly: false
